package at.ac.uibk.gitsearch.service;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.MediaType;

import org.codeability.sharing.plugins.api.SharingPluginConfig;
import org.glassfish.jersey.client.ClientConfig;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
/**
 * management services for plugins.
 * @author Michael Breu
 *
 */
@Service
public class PluginManagementService {
	
	private static String[] registeredPlugins = new String[] {
			"http://localhost:8081/api/sharing/config"
	};
	
	private static SharingPluginConfig[] registeredPluginConfigs;
	
	private final Logger log = LoggerFactory.getLogger(PluginManagementService.class);

	
	@PostConstruct
	public void registerPlugins() {
		List<SharingPluginConfig> results = new ArrayList<>();
		
		for(String registeredPlugin: registeredPlugins) {
			ClientConfig restClientConfig = new ClientConfig();
			
			Client client = ClientBuilder.newClient(restClientConfig);

	        WebTarget target = client.target(registeredPlugin);

	        try {
				SharingPluginConfig config = target.
				                    request().
				                    accept(MediaType.APPLICATION_JSON).
				                    get(SharingPluginConfig.class);
				results.add(config);
			} catch (Exception e) {
				log.error("Cannot load plugin at {}", registeredPlugin, e);
			}
	        registeredPluginConfigs = (SharingPluginConfig[]) results.toArray();
		}
	}
		

}
